// import store from '@/store'
import config from '@/config'
import { getSession } from '@/utils/auth'
import errorCode from '@/utils/errorCode'
import { toast, showConfirm, tansParams } from '@/utils/common'

let timeout = config.timeout
const baseUrl = config.baseUrl

const upload = config => {
	const isSession = config.isSession || false
	config.header = config.header || {}
	if (isSession) {
	  if (getSession()) {
	    config.header['cookie'] = 'JSESSIONID=' + getSession()
	  } else {
	    showConfirm('登录状态已过期，您可以继续留在该页面，或者重新登录?')
	      .then(() => {
	        uni.reLaunch({ url: '/pages/login' })
	      })
	      .catch(() => {
	        return
	      })
	  }
	}
  // get请求映射params参数
  if (config.params) {
    let url = config.url + '?' + tansParams(config.params)
    url = url.slice(0, -1)
    config.url = url
  }
  console.log('upload.config', config);
  return new Promise((resolve, reject) => {
    uni.uploadFile({
      timeout: config.timeout || timeout,
      url: baseUrl + config.url,
      // files: config.files,
      filePath: config.filePath,
      name: config.name || 'file',
      header: config.header,
      formData: config.formData,
      success: (response) => {
				console.log('upload.response', response);
        const { statusCode, data } = response
				try {
					const result = JSON.parse(data)
				} catch (e) {
          toast('上传失败, 请重试')
          reject(-20201)
          return
				}
        const result = JSON.parse(data)
				const returnCode = result.returnCode
        const code = statusCode || 200
        const msg = errorCode[code] || result.returnMsg || errorCode['default']
        if (returnCode == -20201) {
          toast(msg)
          reject(returnCode)
          return
        }
        if (code === 200) {
          resolve(result)
          // } else if (code == 401) {
          //   showConfirm("登录状态已过期，您可以继续留在该页面，或者重新登录?").then(response => {
          //     if (response.confirm) {
          //       store.dispatch('LogOut').then(response => {
          //         uni.reLaunch({ url: '/pages/login' })
          //       })
          //     }
          //   })
          //   reject('无效的会话，或者会话已过期，请重新登录。')
        } else if (code === 500) {
          toast(msg)
          reject('500')
        } else if (code !== 200) {
          toast(msg)
          reject(code)
        }
      },
      fail: (error) => {
        let { errMsg } = error
        if (errMsg == 'Network Error') {
          errMsg = '后端接口连接异常'
        } else if (errMsg.includes('timeout')) {
          errMsg = '系统接口请求超时'
        } else if (errMsg.includes('Request failed with status code')) {
          errMsg = '系统接口' + errMsg.substr(errMsg.length - 3) + '异常'
        } else if (errMsg.includes('request:fail')) {
          errMsg = '网络请求失败'
        }
        toast(errMsg)
        reject(error)
      }
    })
  })
}

export default upload
